/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.HubunganKeluargaDto;
import com.portofolio.service.HubunganKeluargaService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/hubunganKeluarga")
public class HubunganKeluargaController extends LocaleController {
    @Lazy
	@Autowired
    private HubunganKeluargaService hubunganKeluargaService;
    
    
    @ApiOperation("Api Untuk Menyimpan HubunganKeluarga")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody HubunganKeluargaDto entity,HttpServletRequest request) {
        Map<String, Object> result = hubunganKeluargaService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update HubunganKeluarga")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdHubunganKeluarga", required = true) Integer kdHubunganKeluarga,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody HubunganKeluargaDto entity, HttpServletRequest request) {
        Map<String, Object> result = hubunganKeluargaService.update(entity,kdHubunganKeluarga,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus HubunganKeluarga Berdasarkan KdHubunganKeluarga")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdHubunganKeluarga", required = true) Integer kdHubunganKeluarga,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = hubunganKeluargaService.deleteById(kdHubunganKeluarga, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua HubunganKeluarga")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaHubunganKeluarga") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaHubunganKeluarga", required = false) String namaHubunganKeluarga,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = hubunganKeluargaService.grid(page, rows, sort, dir, namaHubunganKeluarga,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan HubunganKeluarga Berdasarkan kdHubunganKeluarga")
    @GetMapping("/findByKdHubunganKeluarga")
    public ResponseEntity<Map<String, Object>> findByKdHubunganKeluarga(
    		@RequestParam(value = "kdHubunganKeluarga", required = true) Integer kdHubunganKeluarga, 
    		HttpServletRequest request) {
        Map<String, Object> result = hubunganKeluargaService.findByKdHubunganKeluarga(kdHubunganKeluarga);
        return RestUtil.getJsonResponse(result);
    }


}
